Subject: Re: Can we clarify the purpose of `git diff -s`?

From: Felipe Contreras <[email-masked]>
Date: Fri, 12 May 2023 13:17:03 -0600

Matthieu Moy wrote:
> [ I apologize for not being more reactive the last few years. I still 
> love Git and this ml, but I'm struggling to find time to contribute. ]
> 
> On 5/11/23 19:37, Junio C Hamano wrote:
> > The behaviour came in the v1.8.4 days with a series that was merged
> > by e2ecd252 (Merge branch 'mm/diff-no-patch-synonym-to-s',
> > 2013-07-22), which
> > 
> >   * made "--no-patch" a synonym for "-s";
> > 
> >   * fixed "-s --patch", in which the effect of "-s" got stuck and did
> >     not allow the patch output to be re-enabled again with "--patch";
> > 
> >   * updated documentation to explain "--no-patch" as a synonym for
> >     "-s".
> > 
> > While it is very clear that the intent of the author was to make it
> > a synonym for "-s" and not a "feature-wise enable/disable" option,
> > that is what we've run with for the past 10 years.
> 
> That's too old for me to remember exactly my state of mind, but if you 
> want to do a bit of archeology, the origin is there:
> 
> https://public-inbox.org/git/[email-masked]/

Yes, I had already sent a link to that thread [1].

> Essentially, Stefan Beller was using 'git show --format="%ad"' and 
> expecting it to show only the author date, and for merge commits it also 
> showed the patch (--cc). I suggested -s and noticed that the option 
> wasn't easily discoverable, hence the patch series to better document it 
> and add --no-patch as a synonym.

That was my understanding. So the goal was to make the silencing of `git show`
output more accessible.

> Probably I did not get all the subtleties of the different kinds of 
> outputs. I guess I considered the output of diff to be the one specified 
> by --format plus the patch (not considering --raw, --stat & friends), 
> hence "get only the output specified by --format" and "disable the 
> patch" were synonym to me. Looking more closely, it's rather clear to me 
> they are not, and that
> 
>    git show --raw --patch --no-patch
> 
> should be equivalent to
> 
>    git show --raw

Indeed, but at the time such funcionality was not easy to achieve, on the other
hand making `--no-patch` be synonymous with `-s` was easy, so that's the path
that was followed. But that was not the goal, that was a means to an end.

Adding `--silent` as a synonym to `-s` would have also served a similar goal.

I sent a patch to add such `--silent` alias [2], and I also sent a patch to
decouple `--no-patch` from `-s` [3].

All these three keep working as it was originally intended by your patch:

 * git show -s
 * git show --silent
 * git show --no-patch

The only difference is that now these are different:

 * git show --patch --raw --no-patch
 * git show --patch --raw --silent

Which wasn't considered back then.

Cheers.

[1] https://lore.kernel.org/git/[email-masked]/
[2] https://lore.kernel.org/git/[email-masked]/
[3] https://lore.kernel.org/git/[email-masked]/

-- 
Felipe Contreras